diff --git a/bbp-includes/bbp-reply-template.php b/bbp-includes/bbp-reply-template.php
index 9fc3839..3b30093 100644
--- a/bbp-includes/bbp-reply-template.php
+++ b/bbp-includes/bbp-reply-template.php
@@ -140,16 +140,18 @@ function bbp_has_replies( $args = '' ) {
 
 		// If pretty permalinks are enabled, make our pagination pretty
 		if ( $wp_rewrite->using_permalinks() ) {
-				
+
 			// Page or single
 			if ( is_page() || is_single() ) {
-				$base = user_trailingslashit( trailingslashit( get_permalink() ) . 'page/%#%/' );
+				$base = get_permalink();
 
 			// Topic
 			} else {
-				$base = user_trailingslashit( trailingslashit( get_permalink( bbp_get_topic_id() ) ) . 'page/%#%/' );
+				$base = get_permalink( bbp_get_topic_id() );
 			}
 
+			$base = trailingslashit( $base ) . user_trailingslashit( $wp_rewrite->pagination_base . '/%#%/' );
+
 		// Unpretty permalinks
 		} else {
 			$base = add_query_arg( 'paged', '%#%' );
@@ -172,9 +174,9 @@ function bbp_has_replies( $args = '' ) {
 
 		// Remove first page from pagination
 		if ( $wp_rewrite->using_permalinks() )
-			$bbp->reply_query->pagination_links = str_replace( 'page/1/\'',     '\'', $bbp->reply_query->pagination_links );
+			$bbp->reply_query->pagination_links = str_replace( $wp_rewrite->pagination_base . "/1/'", "'", $bbp->reply_query->pagination_links );
 		else
-			$bbp->reply_query->pagination_links = str_replace( '&#038;paged=1', '',   $bbp->reply_query->pagination_links );
+			$bbp->reply_query->pagination_links = str_replace( '&#038;paged=1', '', $bbp->reply_query->pagination_links );
 	}
 
 	// Return object
@@ -387,7 +389,7 @@ function bbp_reply_url( $reply_id = 0 ) {
 
 			// Pretty permalinks
 			if ( $wp_rewrite->using_permalinks() ) {
-				$url = trailingslashit( $topic_url ) . trailingslashit( "page/{$reply_page}" ) . $reply_hash;
+				$url = trailingslashit( $topic_url ) . $wp_rewrite->pagination_base . "/$reply_page/$reply_hash";
 
 			// Yucky links
 			} else {
@@ -527,7 +529,7 @@ function bbp_reply_excerpt( $reply_id = 0, $length = 100 ) {
  * @return string Content with the revisions appended
  */
 function bbp_reply_content_append_revisions( $content = '', $reply_id = 0 ) {
-	
+
 	// Bail if in admin
 	if ( is_admin() )
 		return;
diff --git a/bbp-includes/bbp-topic-template.php b/bbp-includes/bbp-topic-template.php
index 167ccd8..933e5a5 100644
--- a/bbp-includes/bbp-topic-template.php
+++ b/bbp-includes/bbp-topic-template.php
@@ -238,24 +238,25 @@ function bbp_has_topics( $args = '' ) {
 
 			// Profile page
 			if ( bbp_is_single_user() )
-				$base = user_trailingslashit( trailingslashit( bbp_get_user_profile_url( bbp_get_displayed_user_id() ) ) . 'page/%#%/' );
+				$base = bbp_get_user_profile_url( bbp_get_displayed_user_id() );
 
 			// View
 			elseif ( bbp_is_single_view() )
-				$base = user_trailingslashit( trailingslashit( bbp_get_view_url() ) . 'page/%#%/' );
+				$base = bbp_get_view_url();
 
 			// Page or single post
 			elseif ( is_page() || is_single() )
-				$base = user_trailingslashit( trailingslashit( get_permalink() ) . 'page/%#%/' );
+				$base = get_permalink();
 
 			// Topic archive
 			elseif ( bbp_is_topic_archive() )
-				$base = user_trailingslashit( trailingslashit( home_url( $bbp->topic_archive_slug ) ) . 'page/%#%/' );
+				$base = home_url( $bbp->topic_archive_slug );
 
 			// Default
 			else
-				$base = user_trailingslashit( trailingslashit( get_permalink( $post_parent ) ) . 'page/%#%/' );
+				$base = get_permalink( $post_parent );
 
+			$base = trailingslashit( $base ) . user_trailingslashit( $wp_rewrite->pagination_base . '/%#%/' );
 		// Unpretty pagination
 		} else {
 			$base = add_query_arg( 'paged', '%#%' );
@@ -276,7 +277,7 @@ function bbp_has_topics( $args = '' ) {
 		$bbp->topic_query->pagination_links = paginate_links ( $bbp_topic_pagination );
 
 		// Remove first page from pagination
-		$bbp->topic_query->pagination_links = str_replace( 'page/1/\'', '\'', $bbp->topic_query->pagination_links );
+		$bbp->topic_query->pagination_links = str_replace( $wp_rewrite->pagination_base . "/1/'", "'", $bbp->topic_query->pagination_links );
 	}
 
 	// Return object
@@ -655,7 +656,7 @@ function bbp_topic_pagination( $args = '' ) {
 
 		// If pretty permalinks are enabled, make our pagination pretty
 		if ( $wp_rewrite->using_permalinks() )
-			$base = user_trailingslashit( trailingslashit( get_permalink( $topic_id ) ) . 'page/%#%/' );
+			$base = trailingslashit( get_permalink( $topic_id ) ) . user_trailingslashit( $wp_rewrite->pagination_base . '/%#%/' );
 		else
 			$base = add_query_arg( 'paged', '%#%' );
 
@@ -683,7 +684,7 @@ function bbp_topic_pagination( $args = '' ) {
 
 			// Remove first page from pagination
 			if ( $wp_rewrite->using_permalinks() )
-				$pagination_links = str_replace( 'page/1/',       '', $pagination_links );
+				$pagination_links = str_replace( $wp_rewrite->pagination_base . '1/',       '', $pagination_links );
 			else
 				$pagination_links = str_replace( '&#038;paged=1', '', $pagination_links );
 
diff --git a/bbpress.php b/bbpress.php
index 40653d5..c48d3a5 100644
--- a/bbpress.php
+++ b/bbpress.php
@@ -931,7 +931,7 @@ class bbPress {
 			$this->topic_tag_slug . '/([^/]+)/edit/?$' => 'index.php?' . $this->topic_tag_tax_id . '=' . $wp_rewrite->preg_index( 1 ) . '&edit=1',
 
 			// Profile Page
-			$this->user_slug      . '/([^/]+)/page/?([0-9]{1,})/?$' => 'index.php?' . $this->user_id  . '=' . $wp_rewrite->preg_index( 1 ) . '&paged=' . $wp_rewrite->preg_index( 2 ),
+			$this->user_slug      . '/([^/]+)/' . $wp_rewrite->pagination_base . '/?([0-9]{1,})/?$' => 'index.php?' . $this->user_id  . '=' . $wp_rewrite->preg_index( 1 ) . '&paged=' . $wp_rewrite->preg_index( 2 ),
 			$this->user_slug      . '/([^/]+)/?$'                   => 'index.php?' . $this->user_id  . '=' . $wp_rewrite->preg_index( 1 ),
 			$this->user_slug      . '/([^/]+)/edit/?$'              => 'index.php?' . $this->user_id  . '=' . $wp_rewrite->preg_index( 1 ) . '&edit=1',
 
@@ -943,7 +943,7 @@ class bbPress {
 			//$this->view_slug      . '/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$' => 'index.php?' . $this->view_id . '=' . $wp_rewrite->preg_index( 1 ) . '&feed='  . $wp_rewrite->preg_index( 2 ),
 
 			// View Page
-			$this->view_slug . '/([^/]+)/page/?([0-9]{1,})/?$' => 'index.php?' . $this->view_id . '=' . $wp_rewrite->preg_index( 1 ) . '&paged=' . $wp_rewrite->preg_index( 2 ),
+			$this->view_slug . '/([^/]+)/' . $wp_rewrite->pagination_base . '/?([0-9]{1,})/?$' => 'index.php?' . $this->view_id . '=' . $wp_rewrite->preg_index( 1 ) . '&paged=' . $wp_rewrite->preg_index( 2 ),
 			$this->view_slug . '/([^/]+)/?$'                   => 'index.php?' . $this->view_id . '=' . $wp_rewrite->preg_index( 1 )
 		);
 