Index: converter.php
===================================================================
--- converter.php	(revision 5154)
+++ converter.php	(working copy)
@@ -949,7 +949,14 @@
 
 							case 'tags':
 								$post_id = wp_set_object_terms( $insert_postmeta['objectid'], $insert_postmeta['name'], 'topic-tag', true );
-								break;
+								$term = get_term_by( 'name', $insert_postmeta['name'], 'topic-tag');
+								if ( false !== $term ) {
+									wp_update_term( $term->term_id, 'topic-tag', array(
+										'description' => $insert_postmeta['description'],
+										'slug'        => $insert_postmeta['slug']
+									) );
+								}
+ 								break;
 
 							/** Forum, Topic, Reply ***************************/
 
Index: converters/bbPress1.php
===================================================================
--- converters/bbPress1.php	(revision 5154)
+++ converters/bbPress1.php	(working copy)
@@ -315,6 +315,18 @@
 			'to_fieldname'    => 'name'
 		);
 
+		// Term slug.
+		$this->field_map[] = array(
+			'from_tablename'  => 'terms',
+			'from_fieldname'  => 'slug',
+			'join_tablename'  => 'term_taxonomy',
+			'join_type'       => 'INNER',
+			'join_expression' => 'USING (term_id)',
+			'to_type'         => 'tags',
+			'to_fieldname'    => 'slug',
+			'callback_method' => 'callback_slug'
+		);
+
 		/** Reply Section *****************************************************/
 
 		// Reply id (Stored in postmeta)
Index: converters/Drupal7.php
===================================================================
--- converters/Drupal7.php	(revision 5154)
+++ converters/Drupal7.php	(working copy)
@@ -269,18 +269,16 @@
 			'to_fieldname'    => 'name'
 		);
 
-		/* Pending: 'Topic-Tag' Descriptions & Slugs with bbPress Importer
-		/* Pending: http://bbpress.trac.wordpress.org/ticket/2399
-
 		// Term slug.
 		$this->field_map[] = array(
 			'from_tablename'  => 'taxonomy_term_data',
-			'from_fieldname'  => 'description',
+			'from_fieldname'  => 'name',
 			'join_tablename'  => 'field_data_field_tags',
 			'join_type'       => 'INNER',
 			'join_expression' => 'ON field_tags_tid = taxonomy_term_data.tid',
 			'to_type'         => 'tags',
-			'to_fieldname'    => 'slug'
+			'to_fieldname'    => 'slug',
+			'callback_method' => 'callback_slug'
 		);
 
 		// Term description.
@@ -293,7 +291,6 @@
 			'to_type'         => 'tags',
 			'to_fieldname'    => 'description'
 		);
-		*/
 
 		/** Reply Section *****************************************************/
 
Index: converters/Example.php
===================================================================
--- converters/Example.php	(revision 5154)
+++ converters/Example.php	(working copy)
@@ -1,7 +1,7 @@
 <?php
 
 /**
- * Example converter base impoprter template for bbPress 
+ * Example converter base impoprter template for bbPress
  *
  * @since bbPress (r4689)
  * @link Codex Docs http://codex.bbpress.org/import-forums/custom-import
@@ -320,6 +320,23 @@
 			'to_fieldname'    => 'name'
 		);
 
+		// Term slug.
+		$this->field_map[] = array(
+			'from_tablename'  => 'tag_table',
+			'from_fieldname'  => 'tagslug',
+			'to_type'         => 'tags',
+			'to_fieldname'    => 'slug',
+			'callback_method' => 'callback_slug'
+		);
+
+		// Term description.
+		$this->field_map[] = array(
+			'from_tablename'  => 'tag_table',
+			'from_fieldname'  => 'tagdescription',
+			'to_type'         => 'tags',
+			'to_fieldname'    => 'description'
+		);
+
 		/** Reply Section *****************************************************/
 
 		// Setup table joins for the reply section at the base of this section
@@ -357,7 +374,7 @@
 			'to_type'         => 'reply',
 			'to_fieldname'    => '_bbp_author_ip'
 		);
-	
+
 		// Reply author.
 		$this->field_map[] = array(
 			'from_tablename'  => 'replies_table',
@@ -454,7 +471,7 @@
 		/** User Section ******************************************************/
 
 		// Setup table joins for the user section at the base of this section
-		
+
 		// Store old User id (Stored in usermeta)
 		$this->field_map[] = array(
 			'from_tablename'  => 'users_table',
Index: converters/PHPFox3.php
===================================================================
--- converters/PHPFox3.php	(revision 5154)
+++ converters/PHPFox3.php	(working copy)
@@ -306,6 +306,15 @@
 			'to_fieldname'    => 'name'
 		);
 
+		// Term slug.
+		$this->field_map[] = array(
+			'from_tablename'  => 'tag',
+			'from_fieldname'  => 'tag_url',
+			'to_type'         => 'tags',
+			'to_fieldname'    => 'slug',
+			'callback_method' => 'callback_slug'
+		);
+
 		/** Reply Section *****************************************************/
 
 		// Reply id (Stored in postmeta)
Index: converters/vBulletin.php
===================================================================
--- converters/vBulletin.php	(revision 5154)
+++ converters/vBulletin.php	(working copy)
@@ -311,6 +311,18 @@
 			'to_fieldname'    => 'name'
 		);
 
+		// Term slug.
+		$this->field_map[] = array(
+			'from_tablename'  => 'tag',
+			'from_fieldname'  => 'tagtext',
+			'join_tablename'  => 'tagcontent',
+			'join_type'       => 'INNER',
+			'join_expression' => 'USING (tagid)',
+			'to_type'         => 'tags',
+			'to_fieldname'    => 'slug',
+			'callback_method' => 'callback_slug'
+		);
+
 		/** Reply Section *****************************************************/
 
 		// Reply id (Stored in postmeta)
Index: converters/vBulletin3.php
===================================================================
--- converters/vBulletin3.php	(revision 5154)
+++ converters/vBulletin3.php	(working copy)
@@ -311,6 +311,18 @@
 			'to_fieldname'    => 'name'
 		);
 
+		// Term slug.
+		$this->field_map[] = array(
+			'from_tablename'  => 'tag',
+			'from_fieldname'  => 'tagtext',
+			'join_tablename'  => 'tagthread',
+			'join_type'       => 'INNER',
+			'join_expression' => 'USING (tagid)',
+			'to_type'         => 'tags',
+			'to_fieldname'    => 'slug',
+			'callback_method' => 'callback_slug'
+		);
+
 		/** Reply Section *****************************************************/
 
 		// Reply id (Stored in postmeta)