Index: src/includes/admin/metaboxes.php
===================================================================
--- src/includes/admin/metaboxes.php	(revision 5464)
+++ src/includes/admin/metaboxes.php	(working copy)
@@ -369,7 +369,7 @@
 		<input name="menu_order" type="number" step="1" size="4" id="menu_order" value="<?php echo esc_attr( $menu_order ); ?>" />
 	</p>

-	<input name="ping_status" type="hidden" id="ping_status" value="open" />
+	<input name="ping_status" type="hidden" id="ping_status" value="closed" />

 	<?php
 	wp_nonce_field( 'bbp_forum_metabox_save', 'bbp_forum_metabox' );
@@ -445,7 +445,7 @@
 		) ); ?>
 	</p>

-	<input name="ping_status" type="hidden" id="ping_status" value="open" />
+	<input name="ping_status" type="hidden" id="ping_status" value="closed" />

 	<?php
 	wp_nonce_field( 'bbp_topic_metabox_save', 'bbp_topic_metabox' );
@@ -539,7 +539,7 @@
 		<?php bbp_reply_to_dropdown( $post_id ); ?>
 	</p>

-	<input name="ping_status" type="hidden" id="ping_status" value="open" />
+	<input name="ping_status" type="hidden" id="ping_status" value="closed" />

 	<?php
 	wp_nonce_field( 'bbp_reply_metabox_save', 'bbp_reply_metabox' );
Index: src/includes/core/filters.php
===================================================================
--- src/includes/core/filters.php	(revision 5463)
+++ src/includes/core/filters.php	(working copy)
@@ -54,6 +54,9 @@
 // Force comments_status on bbPress post types
 add_filter( 'comments_open', 'bbp_force_comment_status' );

+// Force ping_status on bbPress post types
+add_filter( 'pings_open', 'bbp_force_ping_status' );
+
 // Add post_parent__in to posts_where
 add_filter( 'posts_where', 'bbp_query_post_parent__in', 10, 2 );

Index: src/includes/core/theme-compat.php
===================================================================
--- src/includes/core/theme-compat.php	(revision 5463)
+++ src/includes/core/theme-compat.php	(working copy)
@@ -357,7 +357,7 @@
 			'menu_order'            => 0,
 			'pinged'                => '',
 			'to_ping'               => '',
-			'ping_status'           => '',
+			'ping_status'           => 'closed',
 			'comment_status'        => 'closed',
 			'comment_count'         => 0,
 			'filter'                => 'raw',
@@ -435,7 +435,7 @@
  * @uses bbp_set_theme_compat_template() To set the global theme compat template
  */
 function bbp_template_include_theme_compat( $template = '' ) {
-
+
 	/**
 	 * Bail if a root template was already found. This prevents unintended
 	 * recursive filtering of 'the_content'.
@@ -480,7 +480,8 @@
 			'post_title'     => bbp_get_displayed_user_field( 'display_name' ),
 			'post_status'    => bbp_get_public_status_id(),
 			'is_archive'     => false,
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	/** Forums ************************************************************/
@@ -535,7 +536,8 @@
 			'post_type'      => bbp_get_forum_post_type(),
 			'post_status'    => bbp_get_public_status_id(),
 			'is_archive'     => true,
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	// Single Forum
@@ -551,7 +553,8 @@
 			'post_type'      => bbp_get_forum_post_type(),
 			'post_status'    => bbp_get_forum_visibility(),
 			'is_single'      => true,
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	} elseif ( bbp_is_single_forum() ) {
@@ -566,7 +569,8 @@
 			'post_type'      => bbp_get_forum_post_type(),
 			'post_status'    => bbp_get_forum_visibility(),
 			'is_single'      => true,
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	/** Topics ************************************************************/
@@ -605,7 +609,8 @@
 			'post_type'      => bbp_get_topic_post_type(),
 			'post_status'    => bbp_get_public_status_id(),
 			'is_archive'     => true,
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	// Single Topic
@@ -638,7 +643,8 @@
 			'post_type'      => bbp_get_topic_post_type(),
 			'post_status'    => bbp_get_topic_status(),
 			'is_single'      => true,
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	/** Replies ***********************************************************/
@@ -655,7 +661,8 @@
 			'post_content'   => $bbp_shortcodes->display_reply_index(),
 			'post_type'      => bbp_get_reply_post_type(),
 			'post_status'    => bbp_get_public_status_id(),
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	// Single Reply
@@ -683,7 +690,8 @@
 			'post_content'   => $new_content,
 			'post_type'      => bbp_get_reply_post_type(),
 			'post_status'    => bbp_get_reply_status(),
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	/** Views *************************************************************/
@@ -699,7 +707,8 @@
 			'post_content'   => $bbp_shortcodes->display_view( array( 'id' => get_query_var( bbp_get_view_rewrite_id() ) ) ),
 			'post_type'      => '',
 			'post_status'    => bbp_get_public_status_id(),
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	/** Search ************************************************************/
@@ -715,7 +724,8 @@
 			'post_content'   => $bbp_shortcodes->display_search( array( 'search' => get_query_var( bbp_get_search_rewrite_id() ) ) ),
 			'post_type'      => '',
 			'post_status'    => bbp_get_public_status_id(),
-			'comment_status' => 'closed'
+			'comment_status' => 'closed',
+			'ping_status'    => 'closed'
 		) );

 	/** Topic Tags ********************************************************/
@@ -745,6 +755,7 @@
 			'post_title'     => sprintf( __( 'Topic Tag: %s', 'bbpress' ), '<span>' . bbp_get_topic_tag_name() . '</span>' ),
 			'post_status'    => bbp_get_public_status_id(),
 			'comment_status' => 'closed',
+			'ping_status'    => 'closed',
 			'is_tax'         => true
 		) );
 	}
@@ -979,3 +990,33 @@
 	// Allow override of the override
 	return apply_filters( 'bbp_force_comment_status', $retval, $open, $post_id, $post_type );
 }
+
+/**
+ * Force ping_status to 'closed' for bbPress post types
+ *
+ * @since bbPress (rXXXX)
+ *
+ * @param bool $open True if open, false if closed
+ * @param int $post_id ID of the post to check
+ * @return bool True if open, false if closed
+ */
+function bbp_force_ping_status( $open, $post_id = 0 ) {
+
+	// Get the post type of the post ID
+	$post_type = get_post_type( $post_id );
+
+	// Default return value is what is passed in $open
+	$retval = $open;
+
+	// Only force for bbPress post types
+	switch ( $post_type ) {
+		case bbp_get_forum_post_type() :
+		case bbp_get_topic_post_type() :
+		case bbp_get_reply_post_type() :
+			$retval = false;
+			break;
+	}
+
+	// Allow override of the override
+	return apply_filters( 'bbp_force_ping_status', $retval, $open, $post_id, $post_type );
+}
Index: src/includes/replies/functions.php
===================================================================
--- src/includes/replies/functions.php	(revision 5463)
+++ src/includes/replies/functions.php	(working copy)
@@ -38,7 +38,8 @@
 		'post_content'   => '',
 		'post_title'     => '',
 		'menu_order'     => 0,
-		'comment_status' => 'closed'
+		'comment_status' => 'closed',
+		'ping_status'    => 'closed'
 	), 'insert_reply' );

 	// Insert reply
@@ -361,6 +362,7 @@
 		'post_parent'    => $topic_id,
 		'post_type'      => bbp_get_reply_post_type(),
 		'comment_status' => 'closed',
+		'ping_status'    => 'closed',
 		'menu_order'     => bbp_get_topic_reply_count( $topic_id, true ) + 1
 	) );

@@ -1163,7 +1165,7 @@
  * @return array
  */
 function bbp_get_reply_ancestors( $reply_id = 0 ) {
-
+
 	// Validation
 	$reply_id  = bbp_get_reply_id( $reply_id );
 	$ancestors = array();
@@ -1469,7 +1471,7 @@
 	}

 	// Remove reply_to from moved reply
-	delete_post_meta( $move_reply->ID, '_bbp_reply_to' );
+	delete_post_meta( $move_reply->ID, '_bbp_reply_to' );

 	// It is a new topic and we need to set some default metas to make
 	// the topic display in bbp_has_topics() list
@@ -2334,7 +2336,7 @@

 /**
  * Validate a `reply_to` field for hierarchical replies
- *
+ *
  * Checks for 2 scenarios:
  * -- The reply to ID is actually a reply
  * -- The reply to ID does not match the current reply
Index: src/includes/topics/functions.php
===================================================================
--- src/includes/topics/functions.php	(revision 5463)
+++ src/includes/topics/functions.php	(working copy)
@@ -38,6 +38,7 @@
 		'post_content'   => '',
 		'post_title'     => '',
 		'comment_status' => 'closed',
+		'ping_status'    => 'closed',
 		'menu_order'     => 0,
 	), 'insert_topic' );

@@ -330,7 +331,8 @@
 		'post_parent'    => $forum_id,
 		'post_type'      => bbp_get_topic_post_type(),
 		'tax_input'      => $terms,
-		'comment_status' => 'closed'
+		'comment_status' => 'closed',
+		'ping_status'    => 'closed'
 	) );

 	// Insert topic